#include "ConcreteGMStates.h"
#include <stdio.h>

void TitleScreen::toggle(GameManager* gamemgr)
{
    // TitleScreen -> LoadingScreen
    printf("Entering TitleScreen state \n");
    gamemgr->setState(LoadingScreen::getInstance());
    printf("Transition from TitleScreen to LoadingScreen\n");
}

GameManagerState & TitleScreen::getInstance()
{
    static TitleScreen singleton;
    return singleton;
}

void LoadingScreen::toggle(GameManager* gamemgr)
{
    // LoadingScreen -> DayTime
    printf("Entering LoadingScreen state \n");
    gamemgr->setState(DayTime::getInstance());
    printf("Transition from LoadingScreen to DayTime\n");
}

GameManagerState & LoadingScreen::getInstance()
{
    static LoadingScreen singleton;
    return singleton;
}

void DayTime::toggle(GameManager* gamemgr)
{
    // DayTime -> NightTime
    printf("Entering DayTime state \n");
    gamemgr->setState(NightTime::getInstance());
    printf("Transition from DayTime to NightTime\n");
}

GameManagerState & DayTime::getInstance()
{
    static DayTime singleton;
    return singleton;
}

void NightTime::toggle(GameManager* gamemgr)
{    
    if(!gameOver)
    {
        // NightTime -> DayTime
        printf("Entering NightTime state \n");
        gamemgr->setState(DayTime::getInstance());
        printf("Transition from NightTime to DayTime\n");
    } else
    {
        // NightTime -> GameOver
        printf("Entering NightTime state \n");
        gamemgr->setState(GameOver::getInstance());
        printf("Transitioning from NightTime to GameOver \n");
    }
}

GameManagerState & NightTime::getInstance()
{
    static NightTime singleton;
    return singleton;
}

void PauseScreen::toggle(GameManager* gamemgr)
{
    // PauseScreen -> DayTime
    printf("Entering PauseScreen state \n");
    gamemgr->setState(DayTime::getInstance());
    printf("Transition from TitleScreen to LoadingScreen\n");
}

GameManagerState & PauseScreen::getInstance()
{
    static PauseScreen singleton;
    return singleton;
}

void GameOver::toggle(GameManager* gamemgr)
{
    // GameOver -> TitleScreen
    printf("Entering TitleScreen state \n");
    gamemgr->setState(TitleScreen::getInstance());
    printf("Transition from TitleScreen to LoadingScreen\n");
}

GameManagerState & GameOver::getInstance()
{
    static GameOver singleton;
    return singleton;
}
